import 'package:bonfire/bonfire.dart';
import 'package:example/pages/enemy/human_with_collision.dart';
import 'package:example/pages/enemy/melee_enemy.dart';
import 'package:example/pages/enemy/range_enemy.dart';
import 'package:flutter/widgets.dart';

class EnemyPage extends StatelessWidget {
  const EnemyPage({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    const tileSize = 16.0;
    return BonfireWidget(
      map: WorldMapByTiled(
        'tiled/punnyworld/simple_map.tmj',
        objectsBuilder: {
          'range': (properties) => RageEnemy(position: properties.position),
          'melee': (properties) => MeleeEnemy(position: properties.position),
        },
      ),
      joystick: Joystick(
        directional: JoystickDirectional(),
        keyboardConfig: KeyboardConfig(),
      ),
      player: HumanWithCollision(
        position: Vector2(tileSize * 7, tileSize * 8),
      ),
      cameraConfig: CameraConfig(
        zoom: getZoomFromMaxVisibleTile(context, tileSize, 20),
      ),
      backgroundColor: const Color(0xff20a0b4),
    );
  }
}
